<?php
/**
 *    @version [ Wainuiomata ]
 *    @package hwdVideoShare
 *    @copyright (C) 2007 - 2009 Highwood Design
 *    @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 ***
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class SefExt_com_hwdvideoshare extends SefExt
{
    function create(&$uri) {
        global $Itemid;
        $db =& JFactory::getDBO();

		if (!function_exists('URLSafe')) {
			function URLSafe($string)
			{
				jimport( 'joomla.filter.output' );
				$string = JFilterOutput::stringURLSafe($string);

				/* All your other checks */
				return $string;
			}
		}

        $sefConfig =& SEFConfig::getConfig();

		require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_hwdvideoshare'.DS.'config.hwdvideoshare.php');
		require_once(JPATH_SITE.DS.'administrator'.DS.'components'.DS.'com_hwdvideoshare'.DS.'helpers'.DS.'initialise.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_hwdvideoshare'.DS.'hwdvideoshare.class.php');
		$c = hwd_vs_Config::get_instance();
		hwdvsInitialise::language('plugs');
		$db =& JFactory::getDBO();

        $params = SEFTools::getExtParams('com_hwdvideoshare');
		$Itemid = hwd_vs_tools::generateValidItemid($Itemid);

        // Extract variables
        $vars = $uri->getQuery(true);
        extract($vars);
        $title = array();

        $title[] = JoomSEF::_getMenuTitle(@$option, @$task, @$Itemid);

		$title[] = URLSafe(_HWDVS_SEF_VIDEOS);
        if( isset($task) ) {
            switch($task) {
				case 'downloadfile':
				case 'savegroup':
				case 'deletegroup':
				case 'joingroup':
				case 'leavegroup':
				case 'savevideo':
				case 'deletevideo':
				case 'setusertemplate':
				case 'publishvideo':
				case 'rate':
				case 'addfavourite':
				case 'removefavourite':
				case 'addvideotogroup':
				case 'reportvideo':
				case 'reportgroup':
				case 'ajax_rate':
				case 'ajax_addtofavourites':
				case 'ajax_removefromfavourites':
				case 'ajax_reportvideo':
				case 'ajax_addvideotogroup':
				case 'grabjomsocialplayer':
				case 'insertVideo':
				case 'ajax_grabPhotoNavigation':
				case 'ajax_grabPhotoOverlayNavigation':
				  $dosef = false;  // these tasks do not require SEF URL
				break;

				case 'deliverthumb':
				case 'deliverThumb':
					$title[] = URLSafe("deliverThumb");
					unset($task);
					$title[] = $id;
					unset($id);
				break;

				case 'frontpage':
					$title[] = URLSafe(_HWDVS_SEF_VIDEOS);
					unset($task);
				break;

				case 'upload':
					$title[] = URLSafe(_HWDVS_SEF_UPLOAD);
					unset($task);
				break;

				case 'uploadconfirmperl':
					$title[] = URLSafe(_HWDVS_SEF_UPLOADEDP);
					unset($task);
				break;

				case 'uploadconfirmflash':
					$title[] = URLSafe(_HWDVS_SEF_UPLOADEDF);
					unset($task);
				break;

				case 'uploadconfirmphp':
					$title[] = URLSafe(_HWDVS_SEF_UPLOADEDB);
					unset($task);
				break;

				case 'addconfirm':
					$title[] = URLSafe(_HWDVS_SEF_ADDED);
					unset($task);
				break;

				case 'groups':
					$title[] = URLSafe(_HWDVS_SEF_GROUPS);
					unset($task);
				break;

				case 'creategroup':
					$title[] = URLSafe(_HWDVS_SEF_CREATEGROUP);
					unset($task);
				break;

				case 'editgroup':
					$title[] = URLSafe(_HWDVS_SEF_EDITGROUP);
					unset($task);
				break;

				case 'viewgroup':
					$title[] = URLSafe(_HWDVS_SEF_VIEWGROUP);
					unset($task);
				break;

				case 'yourvideos':
					$title[] = URLSafe(_HWDVS_SEF_YV);
					unset($task);
				break;

				case 'yourfavourites':
					$title[] = URLSafe(_HWDVS_SEF_YF);
					unset($task);
				break;

				case 'yourgroups':
					$title[] = URLSafe(_HWDVS_SEF_YG);
					unset($task);
				break;

				case 'yourmemberships':
					$title[] = URLSafe(_HWDVS_SEF_YM);
					unset($task);
				break;

				case 'editvideo':
					$title[] = URLSafe(_HWDVS_SEF_EDITVIDEO);
					unset($task);
				break;

				case 'featuredvideos':
					$title[] = URLSafe(_HWDVS_SEF_FEATUREDVIDEOS);
					unset($task);
				break;

				case 'featuredgroups':
					$title[] = URLSafe(_HWDVS_SEF_FEATUREDGROUPS);
					unset($task);
				break;

				case 'rss':
					$title[] = URLSafe(_HWDVS_SEF_RSS);
					unset($task);
				break;

				case 'categories':
					$title[] = URLSafe(_HWDVS_SEF_CATEGORIES);
					unset($task);
				break;

				case 'gotocategory':
					$menu = &JMenu::getInstance('site');
					$mparams = &$menu->getParams($Itemid);
					$hwdmcid = $mparams->get( 'hwdmcid', '');
					$title[] = $hwdmcid;
					$title[] = URLSafe(_HWDVS_SEF_VC);
					unset($task);
				break;

				case 'nextvideo':
					$title[] = URLSafe(_HWDVS_SEF_NV);
					unset($task);
					$title[] = $category_id;
					unset($category_id);
					$title[] = $video_id;
					unset($video_id);
				break;

				case 'previousvideo':
					$title[] = URLSafe(_HWDVS_SEF_PV);
					unset($task);
					$title[] = $category_id;
					unset($category_id);
					$title[] = $video_id;
					unset($video_id);
				break;

				case 'search':
					$title[] = URLSafe(_HWDVS_SEF_DR);
					unset($task);
					if (!empty($category_id)) {
						$title[] = $category_id;
						unset($category_id);
					}
					if (!empty($pattern)) {
						$title[] = $pattern;
						unset($pattern);
					}
				break;

				case 'displayresults':
					$title[] = URLSafe(_HWDVS_SEF_DR);
					unset($task);
					$title[] = $category_id;
					unset($category_id);
					$title[] = $pattern;
					unset($pattern);
				break;

				case 'viewvideo':
					$vid = intval($video_id);
					$sqlquery = 'SELECT v.title, c.category_name'
						   . ' FROM #__hwdvidsvideos AS v'
						   . ' LEFT JOIN #__hwdvidscategories AS c ON c.id = v.category_id'
						   . ' WHERE v.id = '.$vid
						   ;
					$db->SetQuery($sqlquery);
					$row = $db->loadObject();

					if (!isset($row->category_name)) { $row->category_name = ''; }
					if (!isset($row->title)) { $row->title = ''; }

					$categoryName 	= URLSafe(html_entity_decode($row->category_name));
					$videoName 	    = URLSafe(html_entity_decode($row->title));

					$title[] = URLSafe(_HWDVS_SEF_VIEWVIDEO);
					unset($task);
					$title[] = $video_id;
					unset($video_id);
					$title[] = $categoryName;
					$title[] = $videoName;
				break;

				case 'viewcategory':
					$cid = intval($cat_id);
					$sqlquery = 'SELECT c.category_name'
						   . ' FROM #__hwdvidscategories AS c'
						   . ' WHERE c.id = '.$cid
						   ;
					$db->SetQuery($sqlquery);
					$category_name = $db->loadResult();

					$categoryName 	= URLSafe(html_entity_decode($category_name));

					$title[] = URLSafe(_HWDVS_SEF_VIEWCATEGORY);
					unset($task);
					$title[] = $cat_id;
					unset($cat_id);
					$title[] = $categoryName;
				break;

				case 'viewgroup':
					$gid = intval($group_id);
					$sqlquery = 'SELECT g.group_name'
						   . ' FROM #__hwdvidsgroups AS g'
						   . ' WHERE g.id = '.$gid
						   ;
					$db->SetQuery($sqlquery);
					$group_name = $db->loadResult();

					$groupName 	= URLSafe(html_entity_decode($group_name));

					$title[] = URLSafe(_HWDVS_SEF_VIEWGROUP);
					unset($task);
					$title[] = $group_id;
					unset($group_id);
					$title[] = $groupName;
				break;

				default:
					$title[] = URLSafe(_HWDVS_SEF_VIDEOS);
					unset($task);
				break;
			}

            if( !$sefConfig->appendNonSef ) {
                if( isset($tab) )           $title[] = $tab;
                if( isset($limitstart) )    $title[] = $limitstart;
            }

        }

        if( count($title) == 0 ) {
            $title[] = JoomSEF::_getMenuTitle(@$option, @$task, @$Itemid);
        }

        $newUri = $uri;
        if (count($title) > 0) {
            $nonSefVars = array();
            if( isset($tab) )           $nonSefVars['tab'] = $tab;
            if( isset($limitstart) )    $nonSefVars['limitstart'] = $limitstart;

            $ignoreVars = array();
            if( isset($cbsecurityg1) )  $ignoreVars['cbsecurityg1'] = $cbsecurityg1;

            $newUri = JoomSEF::_sefGetLocation($uri, $title, @$task, @$limit, @$limitstart, @$lang, $nonSefVars, $ignoreVars);
        }

        if( ($params->get('addsuffix', '1') != '1') && isset($suffix) ) {
            $sefConfig->suffix = $suffix;
        }

        return $newUri;
    }
}
?>
